#ifndef _STICKYDRAGMANAGER_H
#define _STICKYDRAGMANAGER_H

#include <windows.h>
#include "windowinfo.h"
#include <map>
#include <list>

class CStickyDragManager
{
public:
	typedef std::map<CWnd *,CWindowInfo> Map;
	typedef std::map<CWnd *,CWindowInfo>::iterator MapIter;
	typedef std::map<CWnd *,CWindowInfo>::const_iterator MapCIter;
	typedef std::map<CWnd *,CWindowInfo>::value_type MapType;
	typedef std::list<CWindowInfo*> WndList;
protected:
	int m_slack; //        .
	Map m_windows; // "" 
	mutable CRITICAL_SECTION m_lock;
	void GetDockedWindows(const CWnd *pWnd,WndList &list) const;
	void GetDockedWindowsEx(const CWnd *pWnd,WndList &ldocked,WndList &lnondocked) const;
	void GetAttachedWindows(const CWnd *pWnd,WndList &list) const;
	void UndockAll(WndList *list=NULL);
public:
	CStickyDragManager(void);
	virtual ~CStickyDragManager();
	void AddWindow(const CWnd *);
	void DeleteWindow(const CWnd *);
	void SetDocker(const CWnd *,const bool);
	void SetDockable(const CWnd *,const bool);
	bool GetDocker(const CWnd *) const;
	bool GetDockable(const CWnd *) const;
	void FixDockState(const CWnd *pWnd);
	void MoveDocked(const CWnd *pWnd,LPRECT pRect);
	void TryDock(const CWnd *pWnd,LPRECT pRect);
	void Resize(const CWnd *pWnd,LPRECT r);
};

#endif //_STICKYDRAGMANAGER_H
